﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestBasicQuery
{
   public partial class Form1 : Form
   {
      // Define the context used to access the database.
      UserFavoritesModelContainer UserFavoritesContext;

      public Form1()
      {
         InitializeComponent();

         // Initialize the database context.
         UserFavoritesContext = new UserFavoritesModelContainer();

         // Query the database for the records you want.
         var dbQuery =
            UserFavoritesContext.UserFavorites.Where(id => id.UserId >= 0).ToArray();
      }

      private void userFavoritesBindingNavigatorSaveItem_Click(object sender, EventArgs e)
      {
         UserFavoritesContext.SaveChanges();
      }

      private void Form1_Load(object sender, EventArgs e)
      {

         // Assign a local copy of the queried records to the
         // binding source.
         userFavoritesBindingSource.DataSource = 
            UserFavoritesContext.UserFavorites.Local;

         // Fill the Favorite Colors list with acceptable colors and
         // choose a default.
         favoriteColorComboBox.DataSource = Enum.GetValues(typeof(ColorNames));
         favoriteColorComboBox.SelectedItem = ColorNames.Red;
      }

      private void toolStripButton1_Click(object sender, EventArgs e)
      {
         // Create a grouped query.
         var Results = UserFavoritesContext.UserFavorites.GroupBy(
            group => group.FavoriteColor);

         // Work through each group.
         StringBuilder Output = new StringBuilder();
         foreach (var Group in Results)
         {
            Output.Append(Group.Key + "\r\n");

            foreach (UserFavorites UserList in Group)
            {
               Output.Append("\t" + UserList.Name + "\r\n");
            }
         }

         // Display the result.
         MessageBox.Show(Output.ToString());
      }
   }
}
